#!/usr/bin/env Rscript

argv = commandArgs(trailingOnly = TRUE);
if (is.null(argv) | length(argv) < 1) {
  cat("Usage: R-install-package package [type] [lib] [repos]\n");
  q(status = 1);
}

type = ifelse(is.na(argv[2]), '{{ r_packages_type }}', argv[2]);
lib = ifelse(is.na(argv[3]), '{{ r_packages_lib }}', argv[3]);

if (type == 'github') {
  repo = argv[1];
  package = unlist(strsplit(repo, "/"))[2];
} else {
  package = argv[1];
}

if (!(package %in% installed.packages(lib.loc = lib)[, 'Package'])) {
  if (type == 'cran') {
    repos = ifelse(is.na(argv[4]), '{{ r_packages_repos.rstrip('/') }}', argv[4]);

    # Temporary fix for: https://github.com/r-lib/xml2/issues/231
    if (package %in% c('devtools', 'xml2')) {
      if (!('withr' %in% installed.packages(lib.loc = lib)[, 'Package'])) {
        install.packages(p, lib, repos)
      }
      withr::with_makevars(c(CXX = 'g++ -std=c++11'), install.packages('xml2', lib, repos))
    }

    withCallingHandlers({
      install.packages(package, lib, repos);
      cat("changed\n");
    }, warning = stop);
  } else if (type == 'bioconductor') {
    withCallingHandlers({
      {% if r_version_35 %}
        BiocManager::install(package, lib = lib, update = FALSE)
      {% else %}
        source('{{ r_bioclite_url }}')
        biocLite(package, lib = lib, suppressUpdates = TRUE, suppressAutoUpdate = TRUE, ask = FALSE)
      {% endif %}
      cat("changed\n");
    }, warning = stop);
  } else if (type == 'github') {
    withCallingHandlers({
      library(remotes)
      install_github(repo, lib = lib)
      cat("changed\n");
    }, warning = stop);
  } else {
    cat("Unrecognised type\n");
    q(status = 1);
  }
}
